Package org.optaplanner.core.impl.heuristic.selector.value.chained

## Class DefaultSubChainSelector<Solution_>

- java.lang.Object
- - org.optaplanner.core.impl.heuristic.selector.AbstractSelector<Solution_>
  - - org.optaplanner.core.impl.heuristic.selector.value.chained.DefaultSubChainSelector<Solution_>

- All Implemented Interfaces:
    `Iterable<SubChain>`, `EventListener`, `ListIterable<SubChain>`, `SelectionCacheLifecycleListener<Solution_>`, `IterableSelector<Solution_,​SubChain>`, `ListIterableSelector<Solution_,​SubChain>`, `Selector<Solution_>`, `SubChainSelector<Solution_>`, `PhaseLifecycleListener<Solution_>`, `SolverLifecycleListener<Solution_>`

      public class DefaultSubChainSelector<Solution_>
      extends AbstractSelector<Solution_>
      implements SubChainSelector<Solution_>, SelectionCacheLifecycleListener<Solution_>

  This is the common `SubChainSelector` implementation.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected List<SubChain>` | `anchorTrailingChainList` |
    `protected static SelectionCacheType` | `CACHE_TYPE` |
    `protected SingletonInverseVariableSupply` | `inverseVariableSupply` |
    `protected int` | `maximumSubChainSize` |
    `protected int` | `minimumSubChainSize` |
    `protected boolean` | `randomSelection` |
    `protected EntityIndependentValueSelector<Solution_>` | `valueSelector` |

    - ### Fields inherited from class org.optaplanner.core.impl.heuristic.selector.AbstractSelector

      `logger, phaseLifecycleSupport, workingRandom`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DefaultSubChainSelector​(EntityIndependentValueSelector<Solution_> valueSelector, boolean randomSelection, int minimumSubChainSize, int maximumSubChainSize)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected long` | `calculateSubChainSelectionSize​(SubChain anchorTrailingChain)` |
    `void` | `constructCache​(SolverScope<Solution_> solverScope)` |
    `void` | `disposeCache​(SolverScope<Solution_> solverScope)` |
    `SelectionCacheType` | `getCacheType()` | Unless this selector itself caches, this returns `SelectionCacheType.JUST_IN_TIME`, even if a selector child caches.
    `long` | `getSize()` | A random JIT `Selector` with `Selector.isNeverEnding()` true should return a size as if it would be able to return each distinct element only once, because the size can be used in `SelectionProbabilityWeightFactory`.
    `GenuineVariableDescriptor<Solution_>` | `getVariableDescriptor()` |
    `boolean` | `isCountable()` | If false, then `Selector.isNeverEnding()` is true.
    `boolean` | `isNeverEnding()` | Is true if `Selector.isCountable()` is false or if this selector is in random order (for most cases).
    `Iterator<SubChain>` | `iterator()` |
    `ListIterator<SubChain>` | `listIterator()` |
    `ListIterator<SubChain>` | `listIterator​(int index)` |
    `void` | `solvingEnded​(SolverScope<Solution_> solverScope)` |
    `void` | `solvingStarted​(SolverScope<Solution_> solverScope)` |
    `String` | `toString()` |

    - ### Methods inherited from class org.optaplanner.core.impl.heuristic.selector.AbstractSelector

      `phaseEnded, phaseStarted, stepEnded, stepStarted`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach`

    - ### Methods inherited from interface org.optaplanner.core.impl.heuristic.selector.IterableSelector

      `spliterator`

    - ### Methods inherited from interface org.optaplanner.core.impl.phase.event.PhaseLifecycleListener

      `phaseEnded, phaseStarted, stepEnded, stepStarted`

- - ### Field Detail

    - #### CACHE_TYPE

          protected static final SelectionCacheType CACHE_TYPE

    - #### valueSelector

          protected final EntityIndependentValueSelector<Solution_> valueSelector

    - #### randomSelection

          protected final boolean randomSelection

    - #### inverseVariableSupply

          protected SingletonInverseVariableSupply inverseVariableSupply

    - #### minimumSubChainSize

          protected final int minimumSubChainSize

    - #### maximumSubChainSize

          protected final int maximumSubChainSize

    - #### anchorTrailingChainList

          protected List<SubChain> anchorTrailingChainList

  - ### Constructor Detail

    - #### DefaultSubChainSelector

          public DefaultSubChainSelector​(EntityIndependentValueSelector<Solution_> valueSelector,
                                         boolean randomSelection,
                                         int minimumSubChainSize,
                                         int maximumSubChainSize)

  - ### Method Detail

    - #### getVariableDescriptor

          public GenuineVariableDescriptor<Solution_> getVariableDescriptor()

      Specified by:
        `getVariableDescriptor` in interface `SubChainSelector<Solution_>`
      Returns:
        never null

    - #### getCacheType

          public SelectionCacheType getCacheType()

      Description copied from interface: `Selector`
      Unless this selector itself caches, this returns `SelectionCacheType.JUST_IN_TIME`, even if a selector child caches.
      Specified by:
        `getCacheType` in interface `Selector<Solution_>`
      Overrides:
        `getCacheType` in class `AbstractSelector<Solution_>`
      Returns:
        never null

    - #### solvingStarted

          public void solvingStarted​(SolverScope<Solution_> solverScope)

      Specified by:
        `solvingStarted` in interface `SolverLifecycleListener<Solution_>`
      Overrides:
        `solvingStarted` in class `AbstractSelector<Solution_>`

    - #### solvingEnded

          public void solvingEnded​(SolverScope<Solution_> solverScope)

      Specified by:
        `solvingEnded` in interface `SolverLifecycleListener<Solution_>`
      Overrides:
        `solvingEnded` in class `AbstractSelector<Solution_>`

    - #### constructCache

          public void constructCache​(SolverScope<Solution_> solverScope)

      Specified by:
        `constructCache` in interface `SelectionCacheLifecycleListener<Solution_>`

    - #### disposeCache

          public void disposeCache​(SolverScope<Solution_> solverScope)

      Specified by:
        `disposeCache` in interface `SelectionCacheLifecycleListener<Solution_>`

    - #### isCountable

          public boolean isCountable()

      Description copied from interface: `Selector`
      If false, then `Selector.isNeverEnding()` is true.
      Specified by:
        `isCountable` in interface `Selector<Solution_>`
      Returns:
        true if all the `ValueRange`s are countable (for example a double value range between 1.2 and 1.4 is not countable)

    - #### isNeverEnding

          public boolean isNeverEnding()

      Description copied from interface: `Selector`
      Is true if `Selector.isCountable()` is false or if this selector is in random order (for most cases). Is never true when this selector is in shuffled order (which is less scalable but more exact).
      Specified by:
        `isNeverEnding` in interface `Selector<Solution_>`
      Returns:
        true if the `Iterator.hasNext()` of the `Iterator` created by `Iterable.iterator()` never returns false (except when it's empty).

    - #### getSize

          public long getSize()

      Description copied from interface: `IterableSelector`
      A random JIT `Selector` with `Selector.isNeverEnding()` true should return a size as if it would be able to return each distinct element only once, because the size can be used in `SelectionProbabilityWeightFactory`.
      Specified by:
        `getSize` in interface `IterableSelector<Solution_,​SubChain>`
      Returns:
        the approximate number of elements generated by this `Selector`, always `>= 0`

    - #### calculateSubChainSelectionSize

          protected long calculateSubChainSelectionSize​(SubChain anchorTrailingChain)

    - #### iterator

          public Iterator<SubChain> iterator()

      Specified by:
        `iterator` in interface `Iterable<Solution_>`

    - #### listIterator

          public ListIterator<SubChain> listIterator()

      Specified by:
        `listIterator` in interface `ListIterable<Solution_>`
      Returns:
        never null, see `List.listIterator()`.
      See Also:
        `List.listIterator()`

    - #### listIterator

          public ListIterator<SubChain> listIterator​(int index)

      Specified by:
        `listIterator` in interface `ListIterable<Solution_>`
      Parameters:
        `index` - lower than the size of this `ListIterable`, see `List.listIterator(int)`.
      Returns:
        never null, see `List.listIterator(int)`.
      See Also:
        `List.listIterator()`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`